

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Getting started &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="The Shyft api" href="../../notebooks/api/api-intro.html" />
    <link rel="prev" title="Concepts" href="concepts.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Getting started</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#general-examples">General examples</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/api/api-intro.html">The Shyft <code class="docutils literal notranslate"><span class="pre">api</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/api/api-essentials.html">Essential <code class="docutils literal notranslate"><span class="pre">api</span></code> classes</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/repository/repositories-intro.html">Exposing the API</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/shyft-intro-course-master/run_api_model.html">Constructing a model using the Shyft API</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#configured-simulation">Configured simulation</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/nea-example/calibration-configured.html">Running a calibration with SHyFT</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/nea-example/simulation-configured.html">Configured Shyft simulations</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/nea-example/run_nea_nidelva.html">A first simulation with Shyft</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/nea-example/advanced_simulation.html">Simulation with the Shyft API</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#advanced-tools">Advanced tools</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/gridpp_geopoints.html">Demonstration of SHyFT API implementation of Kalman Filtering on gridded data</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html">This notebook sets up a Kalman filter and demonstrates how choice of parameters impact the updating</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#2.-Create-Kalman-filter">2. Create Kalman filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#3.-Creates-start-states">3. Creates start states</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#4.-Update-filter">4. Update filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#5.-Plot-results">5. Plot results</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#6.-Test-to-see-how-choice-of-parameters-impact-filter">6. Test to see how choice of parameters impact filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/grid-pp/ordinary_kriging_precipitation.html">Grid post-processing of Met.no data using SHyFT API</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/penman-monteith/penman-monteith-verification-single-method.html">Penman-Monteith Single Method Verification</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/penman-monteith/penman-monteith-sensitivity.html">Penman-Monteith Sensitivity</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/radiation/polar_region_radiaiton.html">Checking calculation of Radiation at Polar Region</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/radiation/radiation-sensitivity-analysis.html">Sensitivity analysis of radiation routine</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/radiation/radiation_camelsdata.html">This notebook demonstarates the radiation algorithm on the camels data:</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
      <li>Getting started</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/content/hydrology/getting_started.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="getting-started">
<h1>Getting started<a class="headerlink" href="#getting-started" title="Permalink to this headline">¶</a></h1>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This Python package is a wrapper around a C++ library. In contrast to Python, C++ allows
<a class="reference external" href="https://en.wikipedia.org/wiki/Function_overloading">function overloading</a> which leads
to some confusion in some <a class="reference external" href="https://en.wikipedia.org/wiki/Integrated_development_environment">IDEs</a>
like <a class="reference external" href="https://www.jetbrains.com/pycharm/">PyCharm</a> and to doc strings unfamiliar to pure
Python developers i.e. full C++ call signatures.</p>
<p>The code in this package is designed to make use of standard help functionality in Python.
You are able to access help functionality using tab completion or <cite>help()</cite>. The “?” or “??”
standards in IPython work, but seem at times to be limited with respect to some of the
doc strings. Therefore, we encourage you to please use <cite>help</cite>.</p>
<p>If you use <cite>help(shyft_object)</cite> and get something that is looks a bit overwhelming or unfamiliar,
just realize that the methods are generally showing how to call a method and what it returns.
If you see <cite>(object)arg1</cite> or <cite>(object)self</cite> as a first argument to a method, that simply means
<a class="reference external" href="https://www.programiz.com/article/python-self-why">the class itself is the first argument</a>.</p>
<p>Example:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>$ python
Python <span class="m">3</span>.8.8 <span class="o">(</span>default, Feb <span class="m">24</span> <span class="m">2021</span>, <span class="m">15</span>:54:32<span class="o">)</span> <span class="o">[</span>...<span class="o">]</span>
Type <span class="s2">&quot;help&quot;</span>, <span class="s2">&quot;copyright&quot;</span>, <span class="s2">&quot;credits&quot;</span> or <span class="s2">&quot;license&quot;</span> <span class="k">for</span> more information.
&gt;&gt;&gt;import shyft.time_series
&gt;&gt;&gt;help<span class="o">(</span>shyft.time_series.Calendar<span class="o">)</span>

<span class="o">[</span>...<span class="o">]</span>

<span class="p">|</span>  Static methods defined here:
<span class="p">|</span>
<span class="p">|</span>  __init__<span class="o">(</span>...<span class="o">)</span>
<span class="p">|</span>      __init__<span class="o">(</span> <span class="o">(</span>Calendar<span class="o">)</span>arg1<span class="o">)</span> -&gt; None
<span class="p">|</span>
<span class="p">|</span>      __init__<span class="o">(</span> <span class="o">(</span>Calendar<span class="o">)</span>arg1, <span class="o">(</span><span class="nb">time</span><span class="o">)</span>tz_offset<span class="o">)</span> -&gt; None :
<span class="p">|</span>          creates a calendar with constant tz-offset
<span class="p">|</span>
<span class="p">|</span>          Args:
<span class="p">|</span>              tz_offset <span class="o">(</span><span class="nb">time</span><span class="o">)</span>: specifies utc offset, time<span class="o">(</span><span class="m">3600</span><span class="o">)</span> gives UTC+01 zone
<span class="p">|</span>
<span class="p">|</span>
<span class="p">|</span>      __init__<span class="o">(</span> <span class="o">(</span>Calendar<span class="o">)</span>arg1, <span class="o">(</span>int<span class="o">)</span>tz_offset<span class="o">)</span> -&gt; None :
<span class="p">|</span>          creates a calendar with constant tz-offset
<span class="p">|</span>
<span class="p">|</span>          Args:
<span class="p">|</span>              tz_offset <span class="o">(</span>int<span class="o">)</span>: seconds utc offset, <span class="m">3600</span> gives UTC+01 zone
<span class="p">|</span>
<span class="p">|</span>
<span class="p">|</span>      __init__<span class="o">(</span> <span class="o">(</span>Calendar<span class="o">)</span>arg1, <span class="o">(</span>str<span class="o">)</span>olson_tz_id<span class="o">)</span> -&gt; None :
<span class="p">|</span>          create a Calendar from Olson timezone id, eg. <span class="s1">&#39;Europe/Oslo&#39;</span>
<span class="p">|</span>
<span class="p">|</span>          Args:
<span class="p">|</span>              olson_tz_id <span class="o">(</span>str<span class="o">)</span>: Olson time-zone id, e.g. <span class="s1">&#39;Europe/Oslo&#39;</span>
<span class="o">[</span>...<span class="o">]</span>
</pre></div>
</div>
<p>What this means is that the <em>class</em> <code class="docutils literal notranslate"><span class="pre">Calendar</span></code> may be instantiated as either:</p>
<ol class="arabic simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar()</span></code>, returning an UTC Calendar</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar(200)</span></code>, indicating a fixed offset of 200 seconds from UTC</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar('Europe/Oslo')</span></code> where the calendar will be ‘tied’ to the “Europe/Oslo” timezone.</p></li>
</ol>
</div>
<p>The best way to get started with Shyft is to work on some of the notebooks that we have developed.
The following notebooks are available in the <a class="reference external" href="https://gitlab.com/shyft-os/shyft-doc">shyft-doc</a> repository.
You can download and run these on your local computer, or browse through them here.</p>
<div class="section" id="general-examples">
<h2>General examples<a class="headerlink" href="#general-examples" title="Permalink to this headline">¶</a></h2>
<p>It is recommended to go through these simple notebooks first, just to get a sense of what Shyft can do.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/api/api-intro.html">The Shyft <code class="docutils literal notranslate"><span class="pre">api</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/api/api-essentials.html">Essential <code class="docutils literal notranslate"><span class="pre">api</span></code> classes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/repository/repositories-intro.html">Exposing the API</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/shyft-intro-course-master/run_api_model.html">Constructing a model using the Shyft API</a></li>
</ul>
</div>
</div>
<div class="section" id="configured-simulation">
<h2>Configured simulation<a class="headerlink" href="#configured-simulation" title="Permalink to this headline">¶</a></h2>
<p>Once you’ve completed that, take a look at the configured examples. These use <cite>yaml</cite> files to keep model
configuration data, and are a good starting point for understanding how to set up a Shyft simulation with your
own data.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/nea-example/calibration-configured.html">Running a calibration with SHyFT</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/nea-example/simulation-configured.html">Configured Shyft simulations</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/nea-example/run_nea_nidelva.html">A first simulation with Shyft</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/nea-example/advanced_simulation.html">Simulation with the Shyft API</a></li>
</ul>
</div>
</div>
<div class="section" id="advanced-tools">
<h2>Advanced tools<a class="headerlink" href="#advanced-tools" title="Permalink to this headline">¶</a></h2>
<p>Shyft contains a lot of functionality. A few pieces are shown in the following notebooks.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/gridpp_geopoints.html">Demonstration of SHyFT API implementation of Kalman Filtering on gridded data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html">This notebook sets up a Kalman filter and demonstrates how choice of parameters impact the updating</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#2.-Create-Kalman-filter">2. Create Kalman filter</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#3.-Creates-start-states">3. Creates start states</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#4.-Update-filter">4. Update filter</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#5.-Plot-results">5. Plot results</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/kalman_updating.html#6.-Test-to-see-how-choice-of-parameters-impact-filter">6. Test to see how choice of parameters impact filter</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/grid-pp/ordinary_kriging_precipitation.html">Grid post-processing of Met.no data using SHyFT API</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/penman-monteith/penman-monteith-verification-single-method.html">Penman-Monteith Single Method Verification</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/penman-monteith/penman-monteith-sensitivity.html">Penman-Monteith Sensitivity</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/radiation/polar_region_radiaiton.html">Checking calculation of Radiation at Polar Region</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/radiation/radiation-sensitivity-analysis.html">Sensitivity analysis of radiation routine</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../notebooks/radiation/radiation_camelsdata.html">This notebook demonstarates the radiation algorithm on the camels data:</a></li>
</ul>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../../notebooks/api/api-intro.html" class="btn btn-neutral float-right" title="The Shyft api" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="concepts.html" class="btn btn-neutral float-left" title="Concepts" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>